## nrn-iv 3.1%2Bgit20221204

=== debian/watch ===
version=4

https://github.com/neuronsimulator/iv/tags .*/@ANY_VERSION@\.tar\.gz

## nrn-iv 3.1+git20221204

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3.0 FATAL_ERROR)
project(INTERVIEWS C CXX)

# =============================================================================
# CMake common project settings
# =============================================================================
set(PROJECT_VERSION_MAJOR 0)
set(PROJECT_VERSION_MINOR 1)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR})


# =============================================================================
# To be able to use project as submodule, avoid using PROJECT_SOURCE_DIR
# =============================================================================
set(IV_PROJECT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(IV_PROJECT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
# For future target customization
set(IV_AS_SUBPROJECT OFF)
if (NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(IV_AS_SUBPROJECT ON)
endif()

# =============================================================================
# Project build options
# =============================================================================
option(IV_ENABLE_SHARED "Build libraries shared or static" OFF)
# Useful for MAC if XQuartz not installed on user machine.
option(IV_ENABLE_X11_DYNAMIC "dlopen X11 after launch" OFF)
# Use only if X11 API changes (Uses very brittle script).
option(IV_ENABLE_X11_DYNAMIC_MAKE_HEADERS "Remake the X11 dynamic .h files." OFF)

# =============================================================================
# CMake build settings
# =============================================================================
set(allowableBuildTypes Custom Debug Release RelWithDebInfo)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      RelWithDebInfo
      CACHE STRING "Empty or one of ${allowableBuildTypes}" FORCE)
elseif(NOT CMAKE_BUILD_TYPE IN_LIST allowableBuildTypes)
  message(FATAL_ERROR "Invalid build type: ${CMAKE_BUILD_TYPE} : Must be one of ${allowableBuildTypes}")
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)

if(NOT IV_ENABLE_SHARED)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  set(IV_LIB_TYPE "STATIC")
else()
  set(IV_LIB_TYPE "SHARED")
endif()

# CYGWIN macros is used in the code
if(${CMAKE_SYSTEM_NAME} MATCHES "CYGWIN")
  set(CYGWIN 1)
endif()

# set up libdir
if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()

# =============================================================================
# Include cmake modules
# =============================================================================
list(APPEND CMAKE_MODULE_PATH ${IV_PROJECT_SOURCE_DIR}/cmake)
include(HelperFunctions)
# do not conflict with nrn PlatformHelper.cmake when submodule.
include(${IV_PROJECT_SOURCE_DIR}/cmake/PlatformHelper.cmake)
include(RpathHelper)
include(CheckIncludeFiles)
include(CheckFunctionExists)

# =============================================================================
# Find dependencies
# =============================================================================
find_package(X11)

if(NOT X11_FOUND AND NOT IV_WINDOWS_BUILD)
  if(APPLE)
    message(FATAL_ERROR "Install XQuartz from https://www.xquartz.org/ to build iv")
  else()
    message(FATAL_ERROR "Install X11 to build iv (e.g. 'apt install libx11-dev libxcomposite-dev' on Ubuntu")
  endif()
endif()

if(NOT X11_Xcomposite_FOUND AND NOT IV_WINDOWS_BUILD)
  message(FATAL_ERROR "libXcomposite is required for X11 support (e.g. 'apt install libxcomposite-dev' on Ubuntu)")
endif()

if(IV_ENABLE_X11_DYNAMIC AND NOT X11_FOUND)
    message(FATAL_ERROR "Cannot IV_ENABLE_X11_DYNAMIC without X11 installed")
endif()

if (IV_ENABLE_X11_DYNAMIC_MAKE_HEADERS)
  # need any Python to run mkdynam.py to generate some .h files
  find_package(PythonInterp REQUIRED)
  if (NOT X11_FOUND)
    message(FATAL_ERROR "Cannot IV_ENABLE_X11_DYNAMIC_MAKE_HEADERS without X11 installed")
  endif()
endif()

# =============================================================================
# Check existance of various headers, functions and directories
# =============================================================================
set(CMAKE_REQUIRED_QUIET TRUE)
message(STATUS "Checking for include files")
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(memory.h HAVE_MEMORY_H)
check_include_files(osfcn.h HAVE_OSFCN_H)
check_include_files(socket.h HAVE_SOCKET_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(string.h HAVE_STRING_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(stropts.h HAVE_STROPTS_H)
check_include_files(stream.h HAVE_STREAM_H)
check_include_files(sys/conf.h HAVE_SYS_CONF_H)
check_include_files(sys/file.h HAVE_SYS_FILE_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(unistd.h HAVE_UNISTD_H)

message(STATUS "Checking for functions")
check_function_exists(getcwd HAVE_GETCWD)
check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists(mmap HAVE_MMAP)
check_function_exists(sigprocmask HAVE_POSIX_SIGNALS)
check_function_exists(socket HAVE_SOCKET)
check_function_exists(strcspn HAVE_STRCSPN)
check_function_exists(strerror HAVE_STRERROR)
check_function_exists(strtod HAVE_STRTOD)
check_function_exists(strtol HAVE_STRTOL)
check_function_exists(uname HAVE_UNAME)

message(STATUS "Checking for include directories")
iv_check_dir_exists(dirent.h HAVE_DIRENT_H)
iv_check_dir_exists(ndir.h HAVE_NDIR_H)
iv_check_dir_exists(sys/dir.h HAVE_SYS_DIR_H)
iv_check_dir_exists(sys/ndir.h HAVE_SYS_NDIR_H)

message(STATUS "Checking for types")
iv_check_type_exists(sys/types.h gid_t int gid_t)
iv_check_type_exists(sys/types.h off_t "long int" off_t)
iv_check_type_exists(sys/types.h pid_t int pid_t)
iv_check_type_exists(sys/types.h size_t "unsigned int" size_t)
iv_check_type_exists(sys/types.h uid_t int uid_t)

# =============================================================================
# Check if signals support
# =============================================================================
# NOTE: check_function_exists(sigsetmask HAVE_BSD_SIGNALS) made obsolete by sigprocmask(2).
# sigsetmask exists but the usage generates a variety of errors. See the old autoconf acinclude.m4
# AC_DEFUN([BASH_SIGNAL_CHECK] For now, use only if don't have posix signals.
if(NOT ${HAVE_POSIX_SIGNALS})
  set(HAVE_BSD_SIGNALS 1)
else()
  set(HAVE_BSD_SIGNALS 0)
endif()

# =============================================================================
# Set return type of signal in RETSIGTYPE
# =============================================================================
iv_check_signal_return_type(RETSIGTYPE)

# =============================================================================
# Generate config.h after all checks
# =============================================================================
add_definitions(-DHAVE_CONFIG_H)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/iv-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake/iv-config.cmake @ONLY)

# =============================================================================
# Include source directories
# =============================================================================
include_directories(${IV_PROJECT_SOURCE_DIR}/src/include ${IV_PROJECT_BINARY_DIR}/src/lib)
add_subdirectory(src/lib)
add_subdirectory(src/bin)

# =============================================================================
# Install binaries and headers
# =============================================================================
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/include/ DESTINATION include)
if(NOT IV_AS_SUBPROJECT)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/iv-config.cmake DESTINATION ${LIB_INSTALL_DIR}/cmake/iv)
    install(EXPORT iv DESTINATION ${LIB_INSTALL_DIR}/cmake/iv)
endif()

# =============================================================================
# Print build status
# =============================================================================
message(STATUS "")
message(STATUS "Configured INTERVIEWS ${PROJECT_VERSION}")
message(STATUS "")
string(TOLOWER "${CMAKE_GENERATOR}" cmake_generator_tolower)
if(cmake_generator_tolower MATCHES "makefile")
  message(STATUS "Some things you can do now:")
  message(STATUS "--------------+--------------------------------------------------------------")
  message(STATUS "Command       |   Description")
  message(STATUS "--------------+--------------------------------------------------------------")
  message(STATUS "make install  | Will install INTERVIEWS to: ${CMAKE_INSTALL_PREFIX}")
  message(STATUS "              | Change the install location of NEURON using:")
  message(STATUS "              |     cmake <src_path> -DCMAKE_INSTALL_PREFIX=<install_path>")
  message(STATUS "--------------+--------------------------------------------------------------")
  message(STATUS "Build option  | Status")
  message(STATUS "--------------+--------------------------------------------------------------")
  message(STATUS "BUILD_TYPE    | ${CMAKE_BUILD_TYPE} (allowed: ${allowableBuildTypes})")
  message(STATUS "SHARED        | ${IV_ENABLE_SHARED}")
  if (X11_FOUND)
    message(STATUS "X11_DYNAMIC   | ${IV_ENABLE_X11_DYNAMIC}")
    if (IV_ENABLE_X11_DYNAMIC_MAKE_HEADERS)
    message(STATUS "              |   ...MAKE_HEADERS=${IV_ENABLE_X11_DYNAMIC_MAKE_HEADERS}")
    endif()
  endif()
  message(STATUS "--------------+--------------------------------------------------------------")
  message(STATUS " See more : https://github.com/neuronsimulator/iv")
  message(STATUS "--------------+--------------------------------------------------------------")
endif()
message(STATUS "")

=== src/bin/CMakeLists.txt ===
# =============================================================================
# Even when IV_ENABLE_X11_DYNAMIC, explicitly link to X11 if static build.
# =============================================================================
if (IV_ENABLE_X11_DYNAMIC AND NOT IV_ENABLE_SHARED)
    set(_ivx11 ${CMAKE_CURRENT_SOURCE_DIR}/../lib/x11_dynam/ivx11_dynamlib.cpp)
    include_directories("${X11_INCLUDE_DIR}")
else()
    set(_ivx11 "")
endif()

# =============================================================================
# idemo
# =============================================================================
set(IDEMO_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/idemo/main.cpp ${_ivx11})
add_executable(idemo ${IDEMO_SOURCE_FILES})
target_link_libraries(idemo interviews ${X11_LIBRARIES})
install(TARGETS idemo DESTINATION bin)

# =============================================================================
# iclass
# =============================================================================
set(ICLASS_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/classbuffer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/classeditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/classinfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/dialogs.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/direct.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/globals.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/iclass.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iclass/main.cpp
    ${_ivx11})

if(NOT IV_WINDOWS_BUILD)
  add_executable(iclass ${ICLASS_SOURCE_FILES})
  target_include_directories(iclass BEFORE PUBLIC ${IV_PROJECT_SOURCE_DIR}/src/include/IV-2_6)
  set_source_files_properties(${ICLASS_SOURCE_FILES} PROPERTIES COMPILE_FLAGS "-Div2_6_compatible")
  target_link_libraries(iclass unidraw interviews ${X11_LIBRARIES})
endif()

# =============================================================================
# idraw
# =============================================================================
set(IDRAW_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idarrow.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idarrowhead.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idarrows.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idcatalog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idcmds.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idcomp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idcreator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/iddialogs.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/ided.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idkybd.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/idvars.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/idraw/main.cpp
    ${_ivx11})

if(NOT IV_WINDOWS_BUILD)
  add_executable(idraw ${IDRAW_SOURCE_FILES})
  target_include_directories(idraw BEFORE PUBLIC ${IV_PROJECT_SOURCE_DIR}/src/include/IV-2_6)
  set_source_files_properties(${IDRAW_SOURCE_FILES} PROPERTIES COMPILE_FLAGS "-Div2_6_compatible")
  target_link_libraries(idraw unidraw interviews ${X11_LIBRARIES})
endif()

# =============================================================================
# Install various targets
# =============================================================================
if(NOT IV_WINDOWS_BUILD)
  install(TARGETS iclass DESTINATION bin)
  install(TARGETS idraw DESTINATION bin)
endif()

=== src/lib/CMakeLists.txt ===
# =============================================================================
# Library sources list
# =============================================================================
set(DISPATCH_SOURCE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/Dispatch/dispatcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Dispatch/iohandler.cpp)

set(IV26_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/adjuster2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/banner.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/border2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/box2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/button2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/compeditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/control.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/deck2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/dialog2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/filebrowser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/filechooser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/frame.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/glue2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/interactor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/matcheditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/menu2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/message.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/painter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/panner2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/perspective.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/rubband.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/rubcurve.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/rubgroup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/rubline.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/rubrect.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/rubverts.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/scene.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/scrollbar2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/scroller2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/sensor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/shape.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/strbrowser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/strchooser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/streditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/subject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/textbuffer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/textdisplay.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/texteditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/tform2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/tray.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/viewport.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/world.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/xbitmap2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/xevent2_6.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/xinter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/xpainter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-2_6/xpattern.cpp)

set(INTERVIEWS_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/dialogs.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/action.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/adjust.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/aggr.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/align.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/alloctbl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/arrcomp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/background.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/bevel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/border.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/box.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/browser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/button.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/character.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/compositor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/comption.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/debug.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/deck.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/fbrowser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/fchooser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/field.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/geometry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/glyph.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/group.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/handler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/hit.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/image.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/input.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/kit.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/label.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/layout.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/lrmarker.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/menu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/mf_dialogs.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/mf_kit.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/mono_kit.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/monoglyph.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/observe.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/ol_dialogs.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/page.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/patch.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/place.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/polyglyph.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/printer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/psfont.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/regexp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/resource.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/rule.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/scrbox.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/shadow.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/simpcomp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/slider.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/smf_kit.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/stencil.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/stepper.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/style.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/superpose.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/target.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/telltale.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/texcomp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/iv3text.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/iv3textbuffer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/tformsetter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/tile.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/transformer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/winbmp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/xymarker.cpp)

if(NOT IV_WINDOWS_BUILD)
  list(APPEND INTERVIEWS_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/ol_kit.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/InterViews/tiff.cpp)
endif()

set(IVX11_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/session.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xbitmap.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xbrush.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xcanvas.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xcolor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xcursor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xdrag.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xevent.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xfont.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xraster.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xreqerr.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xselection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-X11/xwindow.cpp)

set(OS_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/directory.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/file.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/host.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/listimpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/math.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/memory.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/string.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OS/ustring.cpp)

set(TIFF_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_aux.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_ccittrle.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_close.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_cmprs.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_compat.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_dir.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_dirinfo.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_dirread.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_dirwrite.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_dumpmode.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_error.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_fax3.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_fax4.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_flush.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_getimage.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_jpeg.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_lzw.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_machdep.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_next.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_open.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_packbits.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_print.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_read.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_strip.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_swab.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_thunder.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_tile.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_version.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_warning.c
    ${CMAKE_CURRENT_SOURCE_DIR}/TIFF/tif_write.c)

set(IVWIN_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/bitmap.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/brush.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/canvas.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/canvas16.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/color.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/cursor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/display.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/event.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/font.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/ivclean.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/mprinter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/mwapp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/mwlib.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/raster.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/session.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Win/window.cpp)

set(IVMAC_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/bitmap.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/brush.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/canvas.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/color.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/cursor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/display.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/event.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/carbevent.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/font.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/mprinter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/raster.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/session.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IV-Mac/window.cpp)

set(UNIDRAW_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/align.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/brushcmd.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/catalog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/catcmds.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/cglue.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/clipboard.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/colorcmd.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/command.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/component.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/compview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/connect.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/connector.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/creator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/csolver.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/ctrlinfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/damage.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/data.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/datas.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/dialogs.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/edit.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/editor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/editorinfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Unidraw/ellipse.cpp

=== debian/changelog ===
nrn-iv (3.1+git20221204-2) unstable; urgency=medium

  * Conflict with ivtools-dev

 -- Matthias Klumpp <mak@debian.org>  Thu, 02 Feb 2023 20:26:14 +0100

nrn-iv (3.1+git20221204-1) unstable; urgency=medium

  * Initial release, split out of NEURON

 -- Matthias Klumpp <mak@debian.org>  Mon, 23 Jan 2023 21:19:58 +0100

=== debian/control ===
Source: nrn-iv
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libx11-dev,
               libxcomposite-dev,
               libxext-dev,
               zlib1g-dev
Build-Conflicts: ivtools-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/neuronsimulator/iv
Vcs-Git: https://salsa.debian.org/science-team/nrn-iv.git
Vcs-Browser: https://salsa.debian.org/science-team/nrn-iv

Package: libinterviews-dev
Section: libdevel
Architecture: any
Depends: libx11-dev,
         libxcomposite-dev,
         libxext-dev,
         zlib1g-dev,
         ${misc:Depends}
Conflicts: ivtools-dev
Description: InterViews 3.1 for the NEURON simulator
 InterViews is a C++ GUI library from Stanford University
 and Silicon Graphics with a Motif look and feel.
 .
 It is used by the NEURON simulator for legacy UI support,
 and should not be used by newly written code.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_install:
	dh_auto_install
	rm -r $(CURDIR)/debian/libinterviews-dev/usr/bin/

## nrn-iv 3.1+git20250501

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.3.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
 project(INTERVIEWS C CXX)
 
 # =============================================================================
@@ -37,7 +37,7 @@
 # =============================================================================
 # CMake build settings
 # =============================================================================
-set(allowableBuildTypes Custom Debug Release RelWithDebInfo)
+set(allowableBuildTypes Custom Debug Release RelWithDebInfo Fast FastDebug)
 if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE
       RelWithDebInfo
@@ -60,9 +60,17 @@
   set(CYGWIN 1)
 endif()
 
-# set up libdir
-if(NOT DEFINED LIB_INSTALL_DIR)
-    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
+# set up installation dirs
+if(NOT DEFINED IV_LIB_INSTALL_DIR)
+    set(IV_LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
+endif()
+
+if(NOT DEFINED IV_HEADERS_INSTALL_DIR)
+    set(IV_HEADERS_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include)
+endif()
+
+if(NOT DEFINED IV_BIN_INSTALL_DIR)
+    set(IV_BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
 endif()
 
 # =============================================================================
@@ -110,37 +118,18 @@
 # =============================================================================
 set(CMAKE_REQUIRED_QUIET TRUE)
 message(STATUS "Checking for include files")
-check_include_files(fcntl.h HAVE_FCNTL_H)
-check_include_files(malloc.h HAVE_MALLOC_H)
-check_include_files(memory.h HAVE_MEMORY_H)
 check_include_files(osfcn.h HAVE_OSFCN_H)
-check_include_files(socket.h HAVE_SOCKET_H)
-check_include_files(stdint.h HAVE_STDINT_H)
 check_include_files(stdlib.h HAVE_STDLIB_H)
 check_include_files(string.h HAVE_STRING_H)
 check_include_files(strings.h HAVE_STRINGS_H)
 check_include_files(stropts.h HAVE_STROPTS_H)
-check_include_files(stream.h HAVE_STREAM_H)
 check_include_files(sys/conf.h HAVE_SYS_CONF_H)
-check_include_files(sys/file.h HAVE_SYS_FILE_H)
-check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
 check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
-check_include_files(sys/param.h HAVE_SYS_PARAM_H)
 check_include_files(sys/stat.h HAVE_SYS_STAT_H)
-check_include_files(sys/time.h HAVE_SYS_TIME_H)
 check_include_files(unistd.h HAVE_UNISTD_H)
 
 message(STATUS "Checking for functions")
-check_function_exists(getcwd HAVE_GETCWD)
-check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
-check_function_exists(mmap HAVE_MMAP)
 check_function_exists(sigprocmask HAVE_POSIX_SIGNALS)
-check_function_exists(socket HAVE_SOCKET)
-check_function_exists(strcspn HAVE_STRCSPN)
-check_function_exists(strerror HAVE_STRERROR)
-check_function_exists(strtod HAVE_STRTOD)
-check_function_exists(strtol HAVE_STRTOL)
-check_function_exists(uname HAVE_UNAME)
 
 message(STATUS "Checking for include directories")
 iv_check_dir_exists(dirent.h HAVE_DIRENT_H)
@@ -168,11 +157,6 @@
 endif()
 
 # =============================================================================
-# Set return type of signal in RETSIGTYPE
-# =============================================================================
-iv_check_signal_return_type(RETSIGTYPE)
-
-# =============================================================================
 # Generate config.h after all checks
 # =============================================================================
 add_definitions(-DHAVE_CONFIG_H)
@@ -189,10 +173,10 @@
 # =============================================================================
 # Install binaries and headers
 # =============================================================================
-install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/include/ DESTINATION include)
+install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/include/ DESTINATION "${IV_HEADERS_INSTALL_DIR}")
 if(NOT IV_AS_SUBPROJECT)
-    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/iv-config.cmake DESTINATION ${LIB_INSTALL_DIR}/cmake/iv)
-    install(EXPORT iv DESTINATION ${LIB_INSTALL_DIR}/cmake/iv)
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/iv-config.cmake DESTINATION ${IV_LIB_INSTALL_DIR}/cmake/iv)
+    install(EXPORT iv DESTINATION ${IV_LIB_INSTALL_DIR}/cmake/iv)
 endif()
 
 # =============================================================================

=== src/bin/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 set(IDEMO_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/idemo/main.cpp ${_ivx11})
 add_executable(idemo ${IDEMO_SOURCE_FILES})
 target_link_libraries(idemo interviews ${X11_LIBRARIES})
-install(TARGETS idemo DESTINATION bin)
+install(TARGETS idemo DESTINATION ${IV_BIN_INSTALL_DIR})
 
 # =============================================================================
 # iclass
@@ -66,6 +66,6 @@
 # Install various targets
 # =============================================================================
 if(NOT IV_WINDOWS_BUILD)
-  install(TARGETS iclass DESTINATION bin)
-  install(TARGETS idraw DESTINATION bin)
+    install(TARGETS iclass DESTINATION ${IV_BIN_INSTALL_DIR})
+    install(TARGETS idraw DESTINATION ${IV_BIN_INSTALL_DIR})
 endif()

=== debian/changelog ===
nrn-iv (3.1+git20250501-1) unstable; urgency=medium

  * New upstream Git snapshot: 3.1+git20250501
  * Bump standards version: No changes needed
  * Drop d/watch file: There are no releases to scan for

 -- Matthias Klumpp <mak@debian.org>  Sun, 04 May 2025 22:46:14 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libxext-dev,
                zlib1g-dev
 Build-Conflicts: ivtools-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/neuronsimulator/iv
 Vcs-Git: https://salsa.debian.org/science-team/nrn-iv.git
